#include <stdio.h>
#include <stdlib.h>
#include "pic.h"

// IO emulation routines
// External interface emulation

// RD routines. Called very often to check timer & interrupt pins

byte porta_rd(core *pcore)
{
        static byte opa=0;
        byte pa;

        // Square Wave into PA4/T0CKI to check timer
        pa=(pcore->Clocks&0x8)?0x1f:0x0f;

        if (pa!=opa) la_add_event(pcore);

        opa=pcore->porta;
        return pa;
}

byte portb_rd(core *pcore)
{
        static byte opb=0;
        byte pb;

        pb=0xff;

        if (pb!=opb) la_add_event(pcore);

        opb=pcore->portb;
        return pb;
}

// WR routines. Called only on program writes to ports

void porta_wr(core *pcore)
{
        static byte opa=0,otra=0xff;
        if (pcore->porta!=opa || pcore->trisa!=otra) la_add_event(pcore);
        opa=pcore->porta; otra=pcore->trisa;
}

void portb_wr(core *pcore)
{
        static byte opb=0,otrb=0xff;
        if (pcore->portb!=opb || pcore->trisb!=otrb) la_add_event(pcore);
        opb=pcore->portb; otrb=pcore->trisb;
}

// This routine is called periodically every 10000 cycles
// Can be used to simulate slow hardware without performance
// penalty

void do_periodic_update() {}
void trace_interrupt(core *pcore){}
