/************************************************************************
Loader for Hexadecimal files:

	- Intel Hex

*************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pic.h"

unsigned int hexdata(char *p,int nb)
{
	unsigned int i,s;

        nb<<=1;
        for(s=0;nb;nb--) {
                s<<=4;
                i=*p++;
                if (i>'9') { if (i>='a') i-='a'-10; else i-='A'-10; }
                else i-='0';
                s+=i;
        }
	return s;
}

void loadhex(char *fn,word *prog, core *pcore)
{
	unsigned char buf[256],*p;
	int i,j,n,tipo;
	unsigned int dirbase,dir,chk,fdir,f=0;
	FILE *fp;

	if((fp=fopen(fn,"r"))==NULL) {
		printf("Error : Cannot open file. File :%s\n",fn);
		exit(0);
	}

	for(;;){
		fgets(buf,256,fp);
		if (feof(fp)) break;
                if (buf[0]!=':') {
                        fprintf(stderr,"Not an Intel Hex file\n");
                        break;
                }
		p=buf+1;
		chk=0;
		n=hexdata(p,1); p+=2;	// N de bytes de datos
		chk+=n;
		dirbase=hexdata(p,2); p+=4;
		chk+=dirbase>>8;
		chk+=dirbase&0xff;
		tipo=hexdata(p,1); p+=2;
		chk+=tipo;
		if (tipo) break;
		for (i=0;i<n;i++) {
			buf[i]=hexdata(p,1);
			p+=2;
			chk+=buf[i];
		}
		chk+=hexdata(p,1);
		chk&=0xff;
                if (chk) {
                        printf("Error : Checksum Test Failed.\n");
                        break;
                }
                dir=dirbase>>1;
                p=buf;
                for (i=0;i<(n>>1);i++,dir++) {
                        // Intel hex are little endian
                        j=p[1]; j<<=8; j|=*p; p=&p[2];
                        if (dir<1024) prog[dir]=j;
                        if (dir>=0x2100 && dir<0x2140)
                                pcore->eeprom[dir-0x2100]=j;
                        if (dir==0x2007) pcore->config=j;
                }
        }
        fclose(fp);
}
